﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;

namespace BackgroundWorkerProgress
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void worker_DoWork(object sender, DoWorkEventArgs e)
		{
			someLongRunningMethod();
		}

		private void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
		{
			ultraProgressBar1.Value = 0;
			ultraButton1.Enabled = true;
		}

		private void ultraButton1_Click(object sender, EventArgs e)
		{
			worker.RunWorkerAsync();
			ultraButton1.Enabled = false;
		}

		private void someLongRunningMethod()
		{
			int totalIterations = 5000;
			for (int i = 0; i < totalIterations; i++)
			{
				int percent = (int)((float)i / (float)totalIterations * 100);
				Debug.WriteLine(i + ": " + percent);
				this.Invoke(new updateProgressDelegate(updateProgress), percent);
				Thread.Sleep(5);
			}
		}

		private delegate void updateProgressDelegate(int percent);

		private void updateProgress(int percent)
		{
			ultraProgressBar1.Value = percent;
		}
	}
}
